import ConfigParser



class FileConfig(object):
	"""
	Overwrites the defaults with values from file if present
	"""
	configurables = { # Filters out of configuration file only this file. Format: "param": ("section", "method)
		"gateway_delay": ("getfloat", "default"),
		"ami_host": ("get", "ami"),
		"ami_port": ("getint", "ami"),
		"ami_user": ("get", "ami"),
		"ami_pwd": ("get", "ami"),
		"ami_sync": ("getint", "ami"),
		"ami_callstats": ("getint", "ami"),
		"xmpp_host": ("get", "xmpp"),
		"xmpp_port": ("getint", "xmpp"),
		"xmpp_secret": ("get", "xmpp"),
		"xmpp_sdomain": ("get", "xmpp"),
		"xmpp_ping": ("getint", "xmpp"),
		}

	def __init__( self, origConfig ):
		self.cfg = origConfig #Start with original one, overwrite if keys found
		self.parser = ConfigParser.RawConfigParser()
		self.parser.read(origConfig['config'])

	def parse(self):
		"""
		@returns: original configuration with overwritten params if found in configuration file
		"""
		for key in self.configurables:
			try:
				configured = getattr(self.parser, self.configurables[key][0])(self.configurables[key][1], key)
			except:
				pass
			else:
				self.cfg[key] = configured
		return self.cfg
			


