from wokkel.subprotocols import XMPPHandler, IQHandlerMixin

QUERY_ROSTER = "/query[@xmlns='jabber:iq:roster']"

class IQHandler(XMPPHandler, IQHandlerMixin):
	"""
	Implemented following xep-0100
	"""

	iqHandlers = {"/iq[@type='get']" + QUERY_ROSTER: 'onRosterGet',
			"/iq[@type='set']" + QUERY_ROSTER: 'onRosterSet'}

	def connectionMade(self):
		self.xmlstream.addObserver(
			"/iq[@type='get' or @type='set']" + QUERY_ROSTER, self.handleRequest)

	def onRosterGet(self, iq):
		print "Received rosterGet", iq

	def onRosterSet(self, iq):
		"""
		@iq class: <class 'twisted.words.xish.domish.Element'> 
		iq.attributes: {u'from': u'dan@mbitdev/jitsi-2s6fdbt', u'type': u'set', u'id': u'640-23', u'to': u'103@ast1.mbitdev'}
		@iq dir:
			['__class__', '__delattr__', '__delitem__', '__dict__', '__doc__', '__format__', '__getattr__', '__getattribute__', 
			'__getitem__', '__hash__', '__implemented__', '__init__', '__module__', '__new__', '__providedBy__', 
			'__provides__', '__reduce__', '__reduce_ex__', '__repr__', '__setattr__', '__setitem__', '__sizeof__', '__str__', 
			'__subclasshook__', '__weakref__', '_dqa', '_idCounter', 'addChild', 'addContent', 'addElement', 'addRawXml', 
			'addUniqueId', 'attributes', 'children', 'compareAttribute', 'defaultUri', 'elements', 'firstChildElement', 
			'getAttribute', 'hasAttribute', 'localPrefixes', 'name', 'parent', 'swapAttributeValues', 'toXml', 'uri']
		@id name: iq
		@iq uri: jabber:component:accept
		"""
		print "Received rosterSet", iq.name, iq.uri, iq.defaultUri

	
