# Cache here also the voicemail id of users
from twisted.internet import reactor
from mbitrans.settingsdb import SettingsDB

class MailboxDb( object ):

	config = {} # Will be populated here by tap module
	mailboxes = {} # @example: self.mailboxes[vmid] = [ vmnew, vmold, vmurg ]
	statusNotifiers  = set()

	def registerStatusNotifier( self, notifier ):
		"""External functions can use this method to register callback in case of extensions db changes"""
		self.statusNotifiers.add( notifier )

	def unregisterStatusNotifier( self, notifier ):
		"""Unregister from receiving notifies on database changes"""
		self.statusNotifiers.discard( notifierMethod )

	def triggerStatusNotifies( self, extension ):
		"""Registered functions will be called to inform about presence changes on specific extension"""
		for notifier in self.statusNotifiers:
			reactor.callLater(self.config['gateway_delay'], notifier, extension)

	def setMailbox( self, vmid, vmnew, vmold, vmurg ):
		"""
		Add/Update voicemail data of specific entity
		"""
		if vmid not in self.mailboxes.keys() or self.mailboxes[vmid] != [vmnew, vmold, vmurg]:
			self.mailboxes[vmid] = [ vmnew, vmold, vmurg ]
			self.triggerStatusNotifies( vmid )

	def getMailbox( self, vmid ):
		if vmid not in self.mailboxes.keys():
			return []
		return [vmid]+self.mailboxes[vmid]

	def getMailboxes( self ):
		return self.mailboxes.keys()



MailboxDB = MailboxDb()
