"""
Extends Asterisk AMI with not implemented commands
"""
from starpy.manager import AMIProtocol


class MBITAMIProtocol( AMIProtocol ):
	
	delimiter = '\r\n'

	def lineReceived(self, line):
		"""Handle Twisted's report of an incoming line from the manager"""
		self.messageCache.append( line )
		if not line.strip() or line=="SIP-Use-Reason-Header : N\n": #very ugly patch to overcome separator issue of asterisk
			self.dispatchIncoming() # does dispatch and clears cache

	def queueReset( self, queue=None ):
		message = {'action':'queuereset','queue':queue,}
		return self.sendDeferred( message ).addCallback( self.errorUnlessResponse )

	def queueStatusFiltered( self, queue, member ):
		"""
		Ads filter capabilities to existing queueStatus command
		"""
		message = {'action':'queuestatus'}
		if queue:
			message['queue'] = queue
		if member:
			message['member'] = member
		return self.collectDeferred( message, 'QueueStatusComplete' )
