"""
An XMPP subprotocol handler that acts as an XMPP Ping pinger.
"""

from wokkel.ping import PingClientProtocol
from twisted.internet import reactor

class Pinger(PingClientProtocol):
	"""
	I send a ping as soon as I have a connection.
	Repeating pings based on interval
	"""

	def __init__(self, entity, sender, interval):
		self.entity = entity
		self.sender = sender
		self.interval = interval

	def run_ping( self ):
		def cb(response):
			pass # ToDo: add here code to handle response to pings
		self.ping(self.entity, self.sender).addCallback(cb)
		reactor.callLater( self.interval, self.run_ping )

	def connectionInitialized(self):
		self.run_ping()



